package com.sa.ibiz.demo.demo.service.impl;

import java.util.List;
import javax.annotation.Resource;
import org.springframework.stereotype.Service;
import com.baomidou.mybatisplus.core.metadata.IPage;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.sa.ibiz.demo.demo.mapper.UserDictItemMapper;
import com.sa.ibiz.demo.demo.domain.UserDictItem;
import com.sa.ibiz.demo.demo.service.UserDictItemService;
import com.sa.ibiz.demo.ibizutil.service.ServiceImplBase;
import com.sa.ibiz.demo.demo.service.dto.UserDictItemSearchFilter;
import org.springframework.util.DigestUtils;
import org.springframework.util.StringUtils;
import java.util.UUID;
import java.util.Map;
import org.springframework.beans.factory.annotation.Autowired;
import java.util.TreeMap;
import java.util.regex.Matcher;
import java.util.regex.Pattern;
import java.math.BigInteger;
import com.sa.ibiz.demo.ibizutil.annotation.PreField;
import java.lang.reflect.Field;

import com.sa.ibiz.demo.demo.service.UserDictCatService;
import com.sa.ibiz.demo.demo.service.UserDictService;

/**
 * 实体[UserDictItem] 服务对象接口实现
 */
@Service
public class UserDictItemServiceImpl extends ServiceImplBase<UserDictItemMapper, UserDictItem> implements UserDictItemService{

    @Autowired
    private UserDictCatService userdictcatService;
    @Autowired
    private UserDictService userdictService;

    @Resource
    private UserDictItemMapper userdictitemMapper;


    @Override
    public boolean create(UserDictItem et) {
        this.beforeCreate(et);
         return super.create(et);
    }
    @Override
    public boolean update(UserDictItem et){
        this.beforeUpdate(et);
		this.userdictitemMapper.updateOne(et);
		this.get(et);
		return true;
    }

    public Object getEntityKey(UserDictItem et){
		return et.getUserdictitemid();  
    }

    @Override
    public boolean getDraft(UserDictItem et)  {
    if((!StringUtils.isEmpty(et.getUserdictcatid())) && et.getUserdictcat() == null){
            try {
                et.setUserdictcat(userdictcatService.getById(et.getUserdictcatid()));
            }catch (Exception ex){}
        }
    if((!StringUtils.isEmpty(et.getUserdictid())) && et.getUserdict() == null){
            try {
                et.setUserdict(userdictService.getById(et.getUserdictid()));
            }catch (Exception ex){}
        }
            return true;
    }

	public List<UserDictItem> listDefault(UserDictItemSearchFilter filter) {
		return userdictitemMapper.searchDefault(filter,filter.getSelectCond());
	}

	public Page<UserDictItem> searchDefault(UserDictItemSearchFilter filter) {
		return userdictitemMapper.searchDefault(filter.getPage(),filter,filter.getSelectCond());
	}

    public  List<Map<String,Object>> selectRow(String sql){
       return userdictitemMapper.selectRow(sql);
    }

 }